/******************************************************************************
 * chanman.hpp
 * Channel status visualization.
 *-----------------------------------------------------------------------------
 * Copyright (C) 2015 - 2016 Osman Celimli
 * For conditions of distribution and use, see copyright notice in playtone.cpp
 ******************************************************************************/
#ifndef CHANMAN
#define CHANMAN

/******************************************************************************
 * Layout
 ******************************************************************************/
#define CSTAT_RENDER_ENTRIES			2048
#define CSTAT_RENDER_LEN				(sizeof(mszRender) / sizeof(mszRender[0]))

/* |                           ....                            |
 * |  _Channel_Status________________________________________  |
 * | | 0: Idle                                               | |
 * | |    Phase Adj : $0000.0000, Volume $00.00 , $00.00 ... | |
 * | |                                                       | |
 * | | 1: Looping                                            | |
 * | |                         ....                          | |
 */
#define CSTAT_BASE_X					0
#define CSTAT_BASE_Y					170
#define CSTAT_WIDTH						512
#define CSTAT_HEIGHT_BASE				10
#define CSTAT_HEIGHT_PER_CHANNEL		15

#define CSTAT_INFO_ID					3010
#define CSTAT_INFO_X					(CSTAT_BASE_X + 16)
#define CSTAT_INFO_Y					(CSTAT_BASE_Y + 20)
#define CSTAT_INFO_WIDTH				472

#define CSTAT_LABEL_ID					3020
#define CSTAT_LABEL_X					(CSTAT_INFO_X + 0)
#define CSTAT_LABEL_Y					(CSTAT_INFO_Y - 20)
#define CSTAT_LABEL_WIDTH				120
#define CSTAT_LABEL_HEIGHT				16

#define CSTAT_BORDER_ID					3030
#define CSTAT_BORDER_X					(CSTAT_INFO_X - 8)
#define CSTAT_BORDER_Y					(CSTAT_INFO_Y - 4)
#define CSTAT_BORDER_WIDTH				(CSTAT_INFO_WIDTH + 16)


/******************************************************************************
 * ChanMan Class
 ******************************************************************************/
class ChanMan {
	public:
		ChanMan(HWND hParent, CoreChannel_t *pCoreChannels,
                CorePatch_t *pCorePatches, UINT uiChannels);
		~ChanMan();

		LRESULT PaintProc(HWND hWnd, HDC hDC, PAINTSTRUCT psWin);
		LRESULT InvalProc(HWND hWnd);

	private:
		HWND mhParent;
		TCHAR mszRender[CSTAT_RENDER_ENTRIES];

		CoreChannel_t *mpCoreChannels;
		CorePatch_t *mpCorePatches;
		UINT muiChannels;

		HWND mhBorder,mhLabel;
		INT midBorder,midLabel;
		UINT muiHeightM,muiHeightB;
};

#endif
